Index: cpukit/libblock/src/bdbuf.c
===================================================================
--- cpukit/libblock/src/bdbuf.c	(revision 72d2ec4da4ea788335adf921faebf0ac96d67c93)
+++ cpukit/libblock/src/bdbuf.c	(revision 3899a5379f4bfa067e73b4612a547a308a6634ec)
@@ -1115,26 +1493,468 @@
  */
 static void
-bdbuf_write_transfer_done(void *arg, rtems_status_code status, int error)
-{
-    int i;
-    write_tfer_done_arg_t *wtd_arg = arg;
-    blkdev_request *req = wtd_arg->req;
-    bdbuf_buffer **bd_buf_write_store = wtd_arg->write_store;
-    bdbuf_buffer *bd_buf;
-    for (i = 0;i < req->count;i++) {
-      bd_buf = bd_buf_write_store[i];
-      bd_buf->status = status;
-      bd_buf->error = RTEMS_IO_ERROR;
+rtems_bdbuf_read_done (void* arg, rtems_status_code status, int error)
+{
+  rtems_blkdev_request* req = (rtems_blkdev_request*) arg;
+
+  req->error = error;
+  req->status = status;
+
+  rtems_event_send (req->io_task, RTEMS_BDBUF_TRANSFER_SYNC);
+}
+
+/**
+ * Read a block into memory. If the block is not is the cache it is read into
+ * memory. The caller is blocked until the block is read and placed into the
+ * cache.
+ *
+ * @param device The device number (consists of major and minor device number)
+ * @param block Linear media block number
+ * @param bd Pointer to the buffer BD address.
+ * @retval RTEMS_SUCCESSFUL Operation completed successfully.
+ * @return rtems_status_code An error code. Buffer still passed to caller.
+ */
+
+rtems_status_code
+rtems_bdbuf_read (dev_t                device,
+                  rtems_blkdev_bnum    block,
+                  rtems_bdbuf_buffer** bdp)
+{
+  rtems_disk_device*    dd;
+  rtems_bdbuf_pool*     pool;
+  rtems_bdbuf_buffer*   bd = NULL;
+  int                   read_ahead_count;
+  rtems_blkdev_request* req;
+  
+  /*
+   * @todo This type of request structure is wrong and should be removed.
+   */
+#define bdbuf_alloc(size) __builtin_alloca (size)
+
+  req = bdbuf_alloc (sizeof (rtems_blkdev_request) +
+                     (sizeof ( rtems_blkdev_sg_buffer) *
+                      rtems_bdbuf_configuration.max_read_ahead_blocks));
+
+  /*
+   * Do not hold the pool lock when obtaining the disk table.
+   */
+  dd = rtems_disk_obtain (device);
+  if (dd == NULL)
+    return RTEMS_INVALID_ID;
+
+  block += dd->start;
+  
+#if RTEMS_BDBUF_TRACE
+  rtems_bdbuf_printf ("read: %d (dev = %08x)\n", block, device);
+#endif
+  
+  if (block >= dd->size)
+  {
+    rtems_disk_release(dd);
+    return RTEMS_INVALID_NUMBER;
+  }
+
+  req->count = 0;
+  req->bufnum = 0;
+
+  /*
+   * Read the block plus the required number of blocks ahead. The number of
+   * blocks to read ahead is configured by the user and limited by the size of
+   * the disk or reaching a read ahead block that is also cached.
+   *
+   * Limit the blocks read by the size of the disk.
+   */
+  if ((rtems_bdbuf_configuration.max_read_ahead_blocks + block) < dd->size)
+    read_ahead_count = rtems_bdbuf_configuration.max_read_ahead_blocks;
+  else
+    read_ahead_count = dd->size - block;
+
+  pool = rtems_bdbuf_get_pool (dd->phys_dev->pool);
+
+  rtems_bdbuf_lock_pool (pool);
+
+  while (req->count < read_ahead_count)
+  {
+    /*
+     * Get the buffer for the requested block. If the block is cached then
+     * return it. If it is not cached transfer the block from the disk media
+     * into memory.
+     *
+     * We need to clean up any buffers allocated and not passed back to the
+     * caller.
+     */
+    bd = rtems_bdbuf_get_buffer (dd->phys_dev, pool,
+                                 block + req->count,
+                                 req->count == 0 ? FALSE : TRUE);
+
+    /*
+     * Read ahead buffer is in the cache or none available. Read what we
+     * can.
+     */
+    if (!bd)
+      break;
+
+    /*
+     * Is the block we are interested in the cache ?
+     */
+    if ((bd->state == RTEMS_BDBUF_STATE_CACHED) ||
+        (bd->state == RTEMS_BDBUF_STATE_MODIFIED))
+      break;
+
+    bd->state = RTEMS_BDBUF_STATE_TRANSFER;
+    bd->error = 0;
+
+    /*
+     * @todo The use of these req blocks is not a great design.
+     *       The req is a struct with a single 'bufs' declared in the
+     *       req struct and the others are added in the outer level
+     *       struct. This relies on the structs joining as a single
+     *       array and that assumes the compiler packs the structs.
+     *       Why not just place on a list ? The BD has a node that
+     *       can be used.
+     */
+    req->bufs[req->count].user   = bd;
+    req->bufs[req->count].block  = bd->block;
+    req->bufs[req->count].length = dd->block_size;
+    req->bufs[req->count].buffer = bd->buffer;
+    req->count++;
+    req->bufnum++;
+  }
+
+  /*
+   * Transfer any requested buffers. If the request count is 0 we have found
+   * the block in the cache so return it.
+   */
+  if (req->count)
+  {
+    /*
+     * Unlock the pool. We have the buffer for the block and it will be in the
+     * access or transfer state. We may also have a number of read ahead blocks
+     * if we need to transfer data. At this point any other threads can gain
+     * access to the pool and if they are after any of the buffers we have they
+     * will block and be woken when the buffer is returned to the pool.
+     *
+     * If a transfer is needed the I/O operation will occur with pre-emption
+     * enabled and the pool unlocked. This is a change to the previous version
+     * of the bdbuf code.
+     */
+    int result;
+    int b;
+    
+    rtems_bdbuf_unlock_pool (pool);
+
+    req->req = RTEMS_BLKDEV_REQ_READ;
+    req->req_done = rtems_bdbuf_read_done;
+    req->done_arg = req;
+    req->io_task = rtems_task_self ();
+    req->status = RTEMS_RESOURCE_IN_USE;
+    req->error = 0;
+    req->start = dd->start;
+  
+    result = dd->ioctl (dd->phys_dev->dev, RTEMS_BLKIO_REQUEST, req);
+
+    /*
+     * Inspection of the DOS FS code shows the result from this function is
+     * handled and a buffer must be returned.
+     */
+    if (result < 0)
+    {
+      req->error = errno;
+      req->status = RTEMS_IO_ERROR;
+    }
+    else
+    {
+      rtems_status_code sc;
+      rtems_event_set   out;
+      sc = rtems_event_receive (RTEMS_BDBUF_TRANSFER_SYNC,
+                                RTEMS_EVENT_ALL | RTEMS_WAIT,
+                                0, &out);
+
+      if (sc != RTEMS_SUCCESSFUL)
+        rtems_fatal_error_occurred (BLKDEV_FATAL_BDBUF_SWAPOUT_RE);
+    }
+
+    rtems_bdbuf_lock_pool (pool);
+
+    for (b = 1; b < req->count; b++)
+    {
+      bd = req->bufs[b].user;
+      bd->error = req->error;
+      bd->state = RTEMS_BDBUF_STATE_READ_AHEAD;
+      rtems_bdbuf_release (bd);
+    }
+
+    bd = req->bufs[0].user;
+  }
+
+  /*
+   * The data for this block is cached in the buffer.
+   */
+  if (bd->state == RTEMS_BDBUF_STATE_MODIFIED)
+    bd->state = RTEMS_BDBUF_STATE_ACCESS_MODIFIED;
+  else
+    bd->state = RTEMS_BDBUF_STATE_ACCESS;
+
+  rtems_bdbuf_unlock_pool (pool);
+  rtems_disk_release (dd);
+
+  *bdp = bd;
+
+  return RTEMS_SUCCESSFUL;
+}
+
+/**
+ * Release buffer that has been in use. The buffer could have been in the
+ * access state and so with a user of the cache or it was being transfered to
+ * or from the disk media and so with a driver. Wake any waiters. If no one is
+ * waiting and this is the only buffer on the LRU list see if anyone is
+ * waiting. Wake them if they are.
+ *
+ * If the buffer has been modified use the modified release call.
+ *
+ * @param bd The buffer to return to the pool.
+ * @retval RTEMS_SUCCESSFUL This operation always succeeds.
+ */
+
+rtems_status_code
+rtems_bdbuf_release (rtems_bdbuf_buffer* bd)
+{
+  rtems_bdbuf_pool* pool;
+
+  if (bd == NULL)
+    return RTEMS_INVALID_ADDRESS;
+
+  pool = rtems_bdbuf_get_pool (bd->pool);
+
+  rtems_bdbuf_lock_pool (pool);
+
+#if RTEMS_BDBUF_TRACE
+  rtems_bdbuf_printf ("release: %d\n", bd->block);
+#endif
+  
+  if (bd->state == RTEMS_BDBUF_STATE_ACCESS_MODIFIED)
+  {
+    rtems_bdbuf_append_modified (pool, bd);
+  }
+  else
+  {
+    /*
+     * If this is a read ahead buffer place the ready queue. Buffers are
+     * taken from here first. If we prepend then get from the queue the
+     * buffers furthermost from the read buffer will be used.
+     */
+    if (bd->state == RTEMS_BDBUF_STATE_READ_AHEAD)
+      rtems_chain_prepend (&pool->ready, &bd->link);
+    else
+    {
+      bd->state = RTEMS_BDBUF_STATE_CACHED;
+      rtems_chain_append (&pool->lru, &bd->link);
+    }
+  }
+  
+  /*
+   * If there are threads waiting to access the buffer wake them. Wake any
+   * waiters if this is the first buffer to placed back onto the queue.
+   */
+  if (bd->waiters)
+    rtems_bdbuf_wake (pool->access, &pool->access_waiters);
+  else
+  {
+    if (bd->state == RTEMS_BDBUF_STATE_READ_AHEAD)
+    {
+      if (rtems_chain_has_only_one_node (&pool->ready))
+        rtems_bdbuf_wake (pool->waiting, &pool->wait_waiters);
+    }
+    else
+    {
+      if (rtems_chain_has_only_one_node (&pool->lru))
+        rtems_bdbuf_wake (pool->waiting, &pool->wait_waiters);
+    }
+  }
+  
+  rtems_bdbuf_unlock_pool (pool);
+
+  return RTEMS_SUCCESSFUL;
+}
+
+/**
+ * Release buffer that has been in use and has been modified. The buffer could
+ * have been in the access state and so with a user of the cache or it was
+ * being transfered to or from the disk media and so with a driver. Wake any
+ * waiters. If no one is waiting and this is the only buffer on the LRU list
+ * see if anyone is waiting. Wake them if they are.
+ *
+ * If the buffer has been modified use the modified release call.
+ *
+ * @param bd The buffer to return to the pool.
+ * @retval RTEMS_SUCCESSFUL This operation always succeeds.
+ */
+
+rtems_status_code
+rtems_bdbuf_release_modified (rtems_bdbuf_buffer* bd)
+{
+  rtems_bdbuf_pool* pool;
+
+  if (bd == NULL)
+    return RTEMS_INVALID_ADDRESS;
+
+  pool = rtems_bdbuf_get_pool (bd->pool);
+
+  rtems_bdbuf_lock_pool (pool);
+
+#if RTEMS_BDBUF_TRACE
+  rtems_bdbuf_printf ("release modified: %d\n", bd->block);
+#endif
+
+  bd->hold_timer = rtems_bdbuf_configuration.swap_block_hold;
+  
+  rtems_bdbuf_append_modified (pool, bd);
+
+  if (bd->waiters)
+    rtems_bdbuf_wake (pool->access, &pool->access_waiters);
+  
+  rtems_bdbuf_unlock_pool (pool);
+
+  return RTEMS_SUCCESSFUL;
+}
+
+/**
+ * Wait until specified buffer synchronized with disk. Invoked on exchanges
+ * critical for data consistency on the media. The buffer is placed on the sync
+ * list and the swapper is woken. No sync lock is taken as the buffers on the
+ * sync list are taken first and passed to the driver before buffers on the
+ * modified list.
+ *
+ * @note This code does not lock the sync mutex and stop additions to the
+ *       modified queue. This means the buffer could be written and then
+ *       returned to the modified list but will not happen as the buffer's
+ *       state is sync.
+ *
+ * @param bd Pointer to the bdbuf_buffer structure previously obtained using
+ *           get/read primitive.
+ * @retval RTEMS_SUCCESSFUL Always returned.
+ */
+
+rtems_status_code
+rtems_bdbuf_sync (rtems_bdbuf_buffer* bd)
+{
+  rtems_bdbuf_pool* pool;
+  boolean           available;
+
+#if RTEMS_BDBUF_TRACE
+  rtems_bdbuf_printf ("sync: %d\n", bd->block);
+#endif
+  
+  if (bd == NULL)
+    return RTEMS_INVALID_ADDRESS;
+
+  pool = rtems_bdbuf_get_pool (bd->pool);
+
+  rtems_bdbuf_lock_pool (pool);
+
+  bd->state = RTEMS_BDBUF_STATE_SYNC;
+
+  rtems_chain_append (&pool->sync, &bd->link);
+
+  rtems_bdbuf_wake_swapper ();
+
+  available = FALSE;
+  while (!available)
+  {
+    switch (bd->state)
+    {
+      case RTEMS_BDBUF_STATE_CACHED:
+      case RTEMS_BDBUF_STATE_READ_AHEAD:
+      case RTEMS_BDBUF_STATE_MODIFIED:
+      case RTEMS_BDBUF_STATE_ACCESS:
+      case RTEMS_BDBUF_STATE_ACCESS_MODIFIED:
+        available = TRUE;
+        break;
+
+      case RTEMS_BDBUF_STATE_SYNC:
+      case RTEMS_BDBUF_STATE_TRANSFER:
+        bd->waiters++;
+        rtems_bdbuf_wait (pool, &pool->transfer, &pool->transfer_waiters);
+        bd->waiters--;
+        break;
+
+      default:
+        rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_CONSISTENCY);
+    }
+  }
+
+  rtems_bdbuf_unlock_pool (pool);
+  
+  return RTEMS_SUCCESSFUL;
+}
+
+/* rtems_bdbuf_syncdev --
+ *     Synchronize with disk all buffers containing the blocks belonging to
+ *     specified device.
+ *
+ * PARAMETERS:
+ *     dev - block device number
+ *
+ * RETURNS:
+ *     RTEMS status code (RTEMS_SUCCESSFUL if operation completed successfully
+ *     or error code if error is occured)
+ */
+rtems_status_code
+rtems_bdbuf_syncdev (dev_t dev)
+{
+  rtems_disk_device*  dd;
+  rtems_bdbuf_pool*   pool;
+  rtems_status_code   sc;
+  rtems_event_set     out;
+
+#if RTEMS_BDBUF_TRACE
+  rtems_bdbuf_printf ("syncdev: %08x\n", dev);
+#endif
+
+  /*
+   * Do not hold the pool lock when obtaining the disk table.
+   */
+  dd = rtems_disk_obtain (dev);
+  if (dd == NULL)
+    return RTEMS_INVALID_ID;
+
+  pool = rtems_bdbuf_get_pool (dd->pool);
+
+  /*
+   * Take the sync lock before locking the pool. Once we have the sync lock
+   * we can lock the pool. If another thread has the sync lock it will cause
+   * this thread to block until it owns the sync lock then it can own the
+   * pool. The sync lock can only be obtained with the pool unlocked.
+   */
+  
+  rtems_bdbuf_lock_sync (pool);
+  rtems_bdbuf_lock_pool (pool);  
+
+  pool->sync_active    = TRUE;
+  pool->sync_requester = rtems_task_self ();
+  pool->sync_device    = dev;
+  
+  rtems_bdbuf_wake_swapper ();
+  rtems_bdbuf_unlock_pool (pool);
+  
+  sc = rtems_event_receive (RTEMS_BDBUF_TRANSFER_SYNC,
+                            RTEMS_EVENT_ALL | RTEMS_WAIT,
+                            0, &out);
+
+  if (sc != RTEMS_SUCCESSFUL)
+    rtems_fatal_error_occurred (BLKDEV_FATAL_BDBUF_SWAPOUT_RE);
       
-      bd_buf->in_progress = FALSE;
-      _CORE_mutex_Surrender(&bd_buf->transfer_sema, 0, NULL);
-      _CORE_mutex_Flush(&bd_buf->transfer_sema, NULL, 
-			CORE_MUTEX_STATUS_SUCCESSFUL);
-    }
-}
-
-/* bdbuf_read_transfer_done --
+  rtems_bdbuf_lock_pool (pool);
+
+  pool->sync_active = FALSE;
+
+  rtems_bdbuf_unlock_sync (pool);
+  rtems_bdbuf_unlock_pool (pool);
+  
+  return rtems_disk_release(dd);
+}
+
+/* bdbuf_write_transfer_done --
  *     Callout function. Invoked by block device driver when data transfer
- *     from device (read) is completed. This function may be invoked from
+ *     to device (write) is completed. This function may be invoked from
  *     interrupt handler.
  *
